--- Portfile.orig	2017-02-27 10:03:28.000000000 -0800
+++ Portfile	2017-05-17 09:05:48.000000000 -0700
@@ -3,7 +3,7 @@
 PortSystem          1.0
 
 name                sumo
-version             0.29.0
+version             0.30.0
 categories          science devel
 platforms           darwin
 maintainers         gmail.com:tlockhart1976 openmaintainer
@@ -22,8 +22,8 @@
 distname            ${name}-src-${version}
 worksrcdir          ${name}-${version}
 
-checksums           rmd160  56b42d5a7c7a967ae4c17ccd8dda50db5887115e \
-                    sha256  50b627869f829343cc874879317d238615e68b91083f7c401aac198235a690d1
+checksums           rmd160  4b17e0a4b95f0d6a8f4d24e5ff9ceead2f810ec3 \
+                    sha256  2f0825507d756979658061847f47c5d91ec2e5c07e7ebd8839a31ab08ecde742
 
 default_variants    +subseconds +messages
 
@@ -61,17 +61,17 @@
     reinplace -locale C "s#./PHEMlight/#${sharedir}/data/PHEMlight/#" src/tools/emissionsMap_main.cpp
     set python_bin ${frameworks_dir}/Python.framework/Versions/2.7/bin/python2.7
     foreach f [list {*}$python_scripts {*}$python_libs {*}$python_tutorials] {
-        reinplace "s#/usr/bin/env python#${python_bin}#" $f
-        reinplace -E "s|^( *)(sys.path.append)|\\1# \\2|" $f
-        reinplace -E "s|^( *)(.*__file__.*\\.\\.)|\\1# \\2|" $f
-        reinplace -E "s|^( *)(os.path.join.*\\.\\.)|\\1# \\2|" $f
-        reinplace -E "s|^( *)(SUMO_HOME =)|\\1  # \\2|" $f
-        reinplace -E "s|^(if .*SUMO_HOME)|if True:  # \\1|" $f
-        reinplace -E "s|^( +)(.*os.path.join.*SUMO_HOME)|\\1# \\2|" $f
-        reinplace -E "s#^( *)from (assign|costMemory|dijkstra|duaIterate|elements|inputs|network|outputs|routeChoices|statisticsElements|tables)#\\1from sumolib.assign.\\2#" $f
-        reinplace -E "s#^( *)from (miscutils|OrderedMultiSet|output|testUtil)#\\1from sumolib.\\2#" $f
-        reinplace -E "s#^import (detector|route2trips|xsd|xml2csv|collectinghandler|connections|netshiftadaptor|route_departOffset|sort_routes|turndefinitions|rmsd|xml2protobuf)#from sumolib import \\1#" $f
-        reinplace -E "s#^import (os,.*), helpers#import \\1, sumolib.helpers as helpers#" $f
+        reinplace -q "s#/usr/bin/env python#${python_bin}#" $f
+        reinplace -q -E "s|^( *)(sys.path.append)|\\1# \\2|" $f
+        reinplace -q -E "s|^( *)(.*__file__.*\\.\\.)|\\1# \\2|" $f
+        reinplace -q -E "s|^( *)(os.path.join.*\\.\\.)|\\1# \\2|" $f
+        reinplace -q -E "s|^( *)(SUMO_HOME =)|\\1  # \\2|" $f
+        reinplace -q -E "s|^(if .*SUMO_HOME)|if True:  # \\1|" $f
+        reinplace -q -E "s|^( +)(.*os.path.join.*SUMO_HOME)|\\1# \\2|" $f
+        reinplace -q -E "s#^( *)from (assign|costMemory|dijkstra|duaIterate|elements|inputs|network|outputs|routeChoices|statisticsElements|tables)#\\1from sumolib.assign.\\2#" $f
+        reinplace -q -E "s#^( *)from (miscutils|OrderedMultiSet|output|testUtil)#\\1from sumolib.\\2#" $f
+        reinplace -q -E "s#^import (detector|route2trips|xsd|xml2csv|collectinghandler|connections|netshiftadaptor|route_departOffset|sort_routes|turndefinitions|rmsd|xml2protobuf)#from sumolib import \\1#" $f
+        reinplace -q -E "s#^import (os,.*), helpers#import \\1, sumolib.helpers as helpers#" $f
     }
     reinplace -E "s#@BINDIR@#${bindir}#" README.macosx
     reinplace -E "s#@LIBDIR@#${libdir}#" README.macosx
@@ -81,16 +81,21 @@
 
 # List of all python scripts. Used later to ensure usage of python27
 # (instead of the currently active python)
-# available in the next release:
-# tools/tlsCoordinator.py
 set python_scripts [list \
+    tools/createVehTypeDistribution.py \
     tools/districts2poly.py \
     tools/edgesInDistricts.py \
+    tools/extractTest.py \
     tools/generateBidiDistricts.py \
+    tools/osmBuild.py \
+    tools/osmGet.py \
+    tools/osmWebWizard.py \
     tools/pedestrianFlow.py \
     tools/randomTrips.py \
-    tools/route2trips.py \
     tools/route2sel.py \
+    tools/route2trips.py \
+    tools/showDepartsAndArrivalsPerEdge.py \
+    tools/tlsCoordinator.py \
     tools/traceExporter.py \
     tools/assign/Assignment.py \
     tools/assign/cadytsIterate.py \
@@ -157,9 +162,10 @@
     tools/purgatory/kShortest.py \
     tools/purgatory/routes2OD.py \
     tools/route/cutRoutes.py \
+    tools/route/implausibleRoutes.py \
     tools/route/route2alts.py \
     tools/route/route2poly.py \
-    tools/route/routeDiffStats.py \
+    tools/route/routeStats.py \
     tools/route/route_1htoDay.py \
     tools/route/route_departOffset.py \
     tools/route/routecheck.py \